#include "IsValid.hpp"
#include "Problem.hpp"
#include "Sim.hpp"

using std::string;
using std::set;

bool isValid(const Problem& problem,
             const Solution& solution,
             string* pMsg)
{
    set<Coord> coords;
    for (Coord coord : problem)
    {
        if (coord != Coord())
        {
            coords.insert(coord);
        }
    }

    Ship ship;
    for (char move : solution)
    {
        if (move < '1' || move > '9')
        {
            if (pMsg) *pMsg = "Invalid character in solution";
            return false;
        }
        ship.step(move);
        auto it = coords.find(Coord(ship.x, ship.y));
        if (it != coords.end())
        {
            coords.erase(it);
        }
    }

    if (!coords.empty())
    {
        if (pMsg) *pMsg = "Not all locations visited";
        return false;
    }

    return true;
}
