#ifndef PROBLEM_HPP
#define PROBLEM_HPP

#include "Common.hpp"

class Coord
{
public:
    Coord() : x(0), y(0) {}
    Coord(int64_t x_, int64_t y_) : x(x_), y(y_) {}

    bool operator==(const Coord& other) const
    {
        return x == other.x && y == other.y;
    }
    bool operator!=(const Coord& other) const
    {
        return x != other.x || y != other.y;
    }
    bool operator<(const Coord& other) const
    {
        if (y != other.y) return y < other.y;
        return x < other.x;
    }

    int64_t x;
    int64_t y;
};

typedef std::vector<Coord> Problem;

typedef std::string Solution;

bool readProblem(uint64_t id,
                 std::string* pProblemData);
bool writeProblem(uint64_t id,
                  const std::string& problemData);

bool parseProblem(const std::string& problemData,
                  Problem* pProblem,
                  std::string* pMsg = nullptr);
bool readAndParseProblem(uint64_t id,
                         Problem* pProblem,
                         std::string* pMsg = nullptr);
void formatProblem(const Problem& problem,
                   std::string* pProblemData);

bool readSolution(uint64_t id,
                  std::string* pSolution);
bool writeSolution(uint64_t id,
                   const std::string& solution);

#endif
