#ifndef SEXPR_HPP
#define SEXPR_HPP

#include "Common.hpp"

enum class SExprType : uint32_t
{
    List,
    Symbol
};

class SExpr
{
public:
    SExpr();
    SExpr(SExprType type);
    SExpr(std::string symbol);
    SExpr(SExpr&& other) = default;
    ~SExpr();
    SExpr& operator=(SExpr&& other) = default;

    SExprType m_type;
    std::vector<SExpr> m_list;
    std::string m_symbol;

private:
    SExpr(const SExpr& other) = delete;
    SExpr& operator=(const SExpr& other) = delete;
};

void formatSExpr(const SExpr& expr,
                 std::string* pStr);

bool parseSExpr(const std::string& str,
                SExpr* pExpr,
                std::string* pMsg = nullptr);

#endif
